/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the HttpHubspotDestinationAllOf type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &HttpHubspotDestinationAllOf{}

// HttpHubspotDestinationAllOf struct for HttpHubspotDestinationAllOf
type HttpHubspotDestinationAllOf struct {
	OAuthId   *int32  `json:"o_auth_id,omitempty"`
	ApiObject *string `json:"apiObject,omitempty"`
}

// NewHttpHubspotDestinationAllOf instantiates a new HttpHubspotDestinationAllOf object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewHttpHubspotDestinationAllOf() *HttpHubspotDestinationAllOf {
	this := HttpHubspotDestinationAllOf{}
	return &this
}

// NewHttpHubspotDestinationAllOfWithDefaults instantiates a new HttpHubspotDestinationAllOf object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewHttpHubspotDestinationAllOfWithDefaults() *HttpHubspotDestinationAllOf {
	this := HttpHubspotDestinationAllOf{}
	return &this
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *HttpHubspotDestinationAllOf) GetOAuthId() int32 {
	if o == nil || IsNil(o.OAuthId) {
		var ret int32
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *HttpHubspotDestinationAllOf) GetOAuthIdOk() (*int32, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *HttpHubspotDestinationAllOf) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given int32 and assigns it to the OAuthId field.
func (o *HttpHubspotDestinationAllOf) SetOAuthId(v int32) {
	o.OAuthId = &v
}

// GetApiObject returns the ApiObject field value if set, zero value otherwise.
func (o *HttpHubspotDestinationAllOf) GetApiObject() string {
	if o == nil || IsNil(o.ApiObject) {
		var ret string
		return ret
	}
	return *o.ApiObject
}

// GetApiObjectOk returns a tuple with the ApiObject field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *HttpHubspotDestinationAllOf) GetApiObjectOk() (*string, bool) {
	if o == nil || IsNil(o.ApiObject) {
		return nil, false
	}
	return o.ApiObject, true
}

// HasApiObject returns a boolean if a field has been set.
func (o *HttpHubspotDestinationAllOf) HasApiObject() bool {
	if o != nil && !IsNil(o.ApiObject) {
		return true
	}

	return false
}

// SetApiObject gets a reference to the given string and assigns it to the ApiObject field.
func (o *HttpHubspotDestinationAllOf) SetApiObject(v string) {
	o.ApiObject = &v
}

func (o HttpHubspotDestinationAllOf) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o HttpHubspotDestinationAllOf) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.OAuthId) {
		toSerialize["o_auth_id"] = o.OAuthId
	}
	if !IsNil(o.ApiObject) {
		toSerialize["apiObject"] = o.ApiObject
	}
	return toSerialize, nil
}

type NullableHttpHubspotDestinationAllOf struct {
	value *HttpHubspotDestinationAllOf
	isSet bool
}

func (v NullableHttpHubspotDestinationAllOf) Get() *HttpHubspotDestinationAllOf {
	return v.value
}

func (v *NullableHttpHubspotDestinationAllOf) Set(val *HttpHubspotDestinationAllOf) {
	v.value = val
	v.isSet = true
}

func (v NullableHttpHubspotDestinationAllOf) IsSet() bool {
	return v.isSet
}

func (v *NullableHttpHubspotDestinationAllOf) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableHttpHubspotDestinationAllOf(val *HttpHubspotDestinationAllOf) *NullableHttpHubspotDestinationAllOf {
	return &NullableHttpHubspotDestinationAllOf{value: val, isSet: true}
}

func (v NullableHttpHubspotDestinationAllOf) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableHttpHubspotDestinationAllOf) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
